﻿define(["dojo", "epi/dependency", "epi/shell/TypeDescriptorManager"], function(
    dojo,
    dependency,
    TypeDescriptorManager
) {
    return dojo.declare("bynder.BynderAssetDataConverter", null, {
        _store: null,

        sourceDataType: "bynder.contenttypes.bynderimageasset",
        targetDataType: "bynder.contenttypes.bynderimageasset.link",

        constructor: function(params) {
            dojo.mixin(this, params);
            this._store =
                this._store || dependency.resolve("epi.storeregistry").get("BynderAssetStore");
        },

        convert: function(sourceDataType, targetDataType, data) {
            // TODO: different asset types (video/document/audio)
            var types = TypeDescriptorManager.getInheritanceChain(sourceDataType);
            var isBynderAsset = types.indexOf(this.sourceDataType) !== -1;
            if (!isBynderAsset) {
                // Can't render, this will show an error to the user
                return {};
            }

            return dojo.when(this._store.get(data.contentLink), function(content) {
                return {
                    url: content.properties.imageUrl,
                    previewUrl: "", // TODO: set and use previewUrl -> data.previewUrl
                    permanentUrl: content.permanentLink,
                    text: content.name,
                    typeIdentifier: content.typeIdentifier,
                };
            });
        },
    });
});
