﻿define("bynder/BynderInitializer", [
    "dojo/_base/declare",
    "epi/_Module",
    "epi/routes",
    "epi/shell/conversion/ObjectConverterRegistry",
    "bynder/BynderAssetDataConverter",
    "xstyle/css!./Bynder.css",
], function(
    declare,
    _Module,
    routes,
    ObjectConverterRegistry,
    BynderAssetDataConverter
) {
    return declare([_Module], {
        initialize: function() {
            this.inherited(arguments);

            var registry = this.resolveDependency("epi.storeregistry");
            // Register the stores
            var options = {
                idProperty: "contentLink",
            };
            registry.create("BynderAssetStore", this._getRestPath("BynderAssetStore"), options);
            registry.create(
                "BynderAssetMappingStore",
                this._getRestPath("BynderAssetMappingStore"),
                options
            );

            // Register data converter for TinyMCE drop
            var converter = new BynderAssetDataConverter();
            ObjectConverterRegistry.registerConverter(
                converter.sourceDataType,
                converter.targetDataType,
                converter
            );
        },

        _getRestPath: function(name) {
            return routes.getRestPath({
                moduleArea: "bynder",
                storeName: name,
            });
        },
    });
});
