﻿define("bynder/DerivativeHelper", ["dojo/_base/array"], function(array) {
    return {
        getAvailableDerivatives: function(asset, allowedDerivatives) {
            if (asset.type === "video" || asset.type === "document" || asset.type === "audio") {
                return [asset.type];
            }

            var allDerivatives = Object.keys(asset.thumbnails);
            if (!allowedDerivatives) {
                return allDerivatives;
            }

            return array.filter(
                allDerivatives,
                function(derivative) {
                    return allowedDerivatives.indexOf(derivative) !== -1;
                },
                this
            );
        },
    };
});
